Avaya Client Services API Reference (OS X)

- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

Properties | List of all members
CSPresence Class Reference

Presence information for a user. More...

`#import <CSPresence.h>`

Inherits NSObject.

## Properties
CSPresenceOptions | supportedOptions
| Specifies the set of supported options for this presence object. More...
NSString * | presentity
| Presentity is the address of the user that this presence information is associated with. More...
CSPresenceState | overallState
| For incoming presence, the overall presence state as determined by the availability calculation. More...
CSPresenceState | manualState
| The manual presence state set by the user, if any. More...
CSPresenceState | phoneState
| The presence state of the phone channel, if any. More...
NSString * | phoneContact
| The contact address associated with the phone channel, if any. More...
CSPresenceState | videoState
| The presence state of the video channel, if any. More...
NSString * | videoContact
| The contact address associated with the video channel, if any. More...
CSPresenceState | enterpriseIMState
| The presence state of the enterprise instant messaging channel, if any. More...
NSString * | enterpriseIMContact
| The contact address associated with the enterprise instant messaging channel, if any. More...
CSPresenceState | calendarState
| The presence state of the calendar channel, if any. More...
NSDate * | calendarStartDate
| The user's appointment or meeting start date associated with the calendar state, if any. More...
NSDate * | calendarEndDate
| The user's appointment or meeting end date associated with the calendar state, if any. More...
CSPresenceLocationMode | locationMode
| The location-based "mode" of the user, if any. More...
NSString * | note
| The presence note. More...

## Detailed Description

Presence information for a user.

This class is used to create and set up a desired presence state for a local user (outgoing presence) or get presence states for other users (incoming presence). Presence information is divided into 2 parts: an automatic part and an application part.

The automatic part consists of so-called presence channels and their availability. A channel is a way to communicate to a user including communication address and availability of the channel. The channels include a phone channel, a video channel, an IM channel and a calendar channel. For instance, phone channel represents a phone number of a user and current CSPresenceState of the channel. If the state of the phone channel is available, the user is able to receive calls. If the state is "on a call", the user is unlikely to accept a new call. The automatic part of presence information is controlled by the library and used for incoming presence only.

The application part of presence information consists of manually published CSPresenceState, CSPresenceLocationMode and a note. These are used for both incoming and outgoing presence, and controlled by the application. Application CSPresenceState is a presence state that a user wants to set their client to. Application CSPresenceLocationMode is also controlled by the user specifying their current location. Application note is just a short string representing some user comment regarding their current status.

Although there are many aspects to presence information, there is also an overall presence state populated automatically. The overall state should be used to represent the state of the user.

See also
  CSPresenceService

## Property Documentation

- (NSDate*) calendarEndDate
| read nonatomic assign

The user's appointment or meeting end date associated with the calendar state, if any.

- (NSDate*) calendarStartDate
| read nonatomic assign

The user's appointment or meeting start date associated with the calendar state, if any.

- (CSPresenceState) calendarState
| read nonatomic assign

The presence state of the calendar channel, if any.

- (NSString*) enterpriseIMContact
| read nonatomic assign

The contact address associated with the enterprise instant messaging channel, if any.

- (CSPresenceState) enterpriseIMState
| read write nonatomic assign

The presence state of the enterprise instant messaging channel, if any.

- (CSPresenceLocationMode) locationMode
| read write nonatomic assign

The location-based "mode" of the user, if any.

- (CSPresenceState) manualState
| read write nonatomic assign

The manual presence state set by the user, if any.

If the value of the manual state is CSPresenceStateUnspecified, no manual state is set and the overall presence state is determined automatically.

- (NSString*) note
| read write nonatomic copy

The presence note.

- (CSPresenceState) overallState
| read nonatomic assign

For incoming presence, the overall presence state as determined by the availability calculation.

- (NSString*) phoneContact
| read nonatomic assign

The contact address associated with the phone channel, if any.

- (CSPresenceState) phoneState
| read write nonatomic assign

The presence state of the phone channel, if any.

- (NSString*) presentity
| read nonatomic assign

Presentity is the address of the user that this presence information is associated with.

- (CSPresenceOptions) supportedOptions
| read write nonatomic assign

Specifies the set of supported options for this presence object.

Some aspects of the presence object are optional and these options control how the presence publication will manage the tuples associated with the optional elements. For example, if the CSPresenceOptions::CSPresenceOptionNote option is set and the note string is empty, any existing note on the server will be removed. If the option is not set the note will not be changed.

- (NSString*) videoContact
| read nonatomic assign

The contact address associated with the video channel, if any.

- (CSPresenceState) videoState
| read write nonatomic assign

The presence state of the video channel, if any.

The documentation for this class was generated from the following file:

- CSPresence.h